<?php
/***************************************\
|			PHP OPTIMISATEUR			|
|	  Plugin Charlie's Content 1.0		|
\***************************************/

## Génère des miniatures pour divers types de fichiers

$CC_charlies_exts = array( // all extensions supported by Charlies' Content
	'flv','swf','pls','m3u','wav','mid','au','aif','mp3','pdf',
	'asf','wmv','divx','xvid','aiff','aac','bmp','gsm','mov','mpg',
	'mpeg','mp4','m4a','psd','qt','qtif','qif','qti','snd','tif',
	'tiff','3g2','3pg','zip','rar','gpx','3gp',
);
$CC_video_exts = array( // extensions tested with FFmpeg
	'wmv','mov','mkv','mp4','mpg','flv','asf','xvid','divx','mpeg',
	'avi','rm', # <-- additional formats
);
$CC_video_time = $CONF['Plugins']['charlies_content']['video_time'];

if (!function_exists('ffmpeg')) {
function ffmpeg($param, $log=true) {
	global $LOG;

	exec('include\ffmpeg.exe '. $param .' 2>&1', $out);
	
	if ($log) {
		$LOG[] = 'FFmpeg conversion : ' . $param;
	} else {
		return $out;
	}
}
}

if (in_arrayi($file['ext'], $CC_video_exts)) {
	// copie la video
	copy_log($FilesSource[$i], $FilesSortie[$i]);
	
	// infos sur le fichier
	$infos = ffmpeg('-i "'. $FilesSource[$i] .'"', false);
	$infos = implode('|', $infos);
	
	// taille de la video
	if (preg_match('#\, (\d+)x(\d+)#s', $infos, $sizes)) {
		$FileInfos = array(
			'Width' => $sizes[1],
			'Height' => $sizes[2],
		);
	}

	// position de la miniature
	$second = 10;
	if ($CC_video_time == 'rand') {
		if (preg_match('#Duration: ((\d+):(\d+):(\d+))#s', $infos, $time)) {
			$total = ($time[2] * 3600) + ($time[3] * 60) + $time[4];
			$second = rand(1, ($total - 1));
		}
	} else if (is_int($CC_video_time)) {
		$second = $CC_video_time;
	}
	
	// création d'un ficher pleine taille temporaire
	mkdir('temp', 0777, true);
	ffmpeg('-i "'. $FilesSource[$i] .'" -an -ss '.$second.' -t 1 -r 1 -y -vcodec mjpeg -f mjpeg "temp/'.$file['name'].'.jpg"');	
	
	// miniature, utilise Create Custom Thumbs si activé
	if (
		isset($CONF['Plugins']['create_custom_thumbs']) 
		AND $CONF['Plugins']['create_custom_thumbs']['active']
	) {
		unset($BlockAll);
		$CCT_filesource = 'temp/'.$file['name'].'.jpg';
		include('plugins/create_custom_thumbs/main.php');
		$BlockAll['main'] = true;
	
	} else {
		nconvert('-q '.$CONF['Qthumbnail'].' -out jpeg -o "'.$file['folder_out'].'thumbnail/'.$CONF['prefixe_mini'].$file['name'].'.jpg" -dpi 72 '.$CONF['convOptions'].' -resize '.$CONF['DIMthumbnail'].' '.$CONF['DIMthumbnail'].' -rmeta -rexifthumb "temp/'.$file['name'].'.jpg"');
	}

	// suppression des fichiers temporaires
	@rrmdir('temp');
	
	$BlockThumbnail['charlies_content'] = true;
	$BlockNormal['charlies_content'] = true;
	$BlockHigh['charlies_content'] = true;
	
} else if (in_arrayi($file['ext'], $CC_charlies_exts)) {
	// copie le fichier
	copy_log($FilesSource[$i], $FilesSortie[$i]);
	
	$BlockThumbnail['charlies_content'] = true;
	$BlockNormal['charlies_content'] = true;
	$BlockHigh['charlies_content'] = true;
}

?>